import {BLINKLOADER_API_URL} from '../../env';

export default config => (
	new Promise((resolve, reject) =>
		config.fetch(`${BLINKLOADER_API_URL}/quota?api-key=${config.config.getApiKey()}`).then(res => {
			if (res.status === 200) {
				return res.json();
			}
			reject(config.decorators.errorExit('checking monthly usage quota', res.statusText));
		}).then(json => {
			if (json.errorMessage) {
				return reject(config.decorators.errorExit('checking monthly usage quota: ' + json.errorMessage));
			}
			if (json.remains <= 0) {
				return reject(config.decorators.errorExit('checking quota: not enough quota'));
			}
			config.decorators.message(
				config.decorators.yellow('INFO') + '      ',
				'there are ' + config.decorators.gray(parseInt(json.remains, 10).toLocaleString()) + ' optimization units on your balance'
			);
			config.decorators.n();
			resolve(config);
		}).catch(err => {
			reject(config.decorators.errorExit('checking monthly usage quota', err));
			config.decorators.n();
		})
	)
);
