import {BLINKLOADER_API_URL} from '../../env';

export default config => (
	new Promise((resolve, reject) =>
		config.fetch(`${BLINKLOADER_API_URL}/optimization/create?api-key=${config.config.getApiKey()}&optimizations=${config.config.getOptimizations().join(',')}`).then(res => {
			if (res.status === 200) {
				config.decorators.checkbox(`established connection with the Blinkloader API`);
				return res.json();
			}
			reject(config.decorators.apiCallError('creating optimization', res.statusText));
		}).then(json => {
			if (json.errorMessage) {
				reject(config.decorators.error('creating optimization: ' + json.errorMessage));
			}
			config.projectID = json['project-id'];
			config.optimizationCreated = true;
			resolve(config);
		}).catch(err => {
			reject(config.decorators.error('creating optimization', err));
		})
	)
);
