export default config => new Promise((resolve, reject) => {
	const readyPromises = [];
	config.pageLinks.forEach((pageLink, i) => {
		readyPromises[i] = new Promise((resolve, reject) => {
			config.fetch(pageLink[config.pages[i]]).then(res => {
				if (res.status === 200) {
					return res.json();
				}
				reject(config.decorators.apiCallError('error occurred while fetching the pages', res.statusText));
			}).then(json => {
				if (json.errorMessage) {
					reject(config.decorators.error('error occurred while fetching the pages: ' + json.errorMessage));
				} else if (json.page) {
					config.config.writeFile(config.config.getSiteOptimizedDir() + config.pages[i], json.page, err => err ? config.decorators.error(err) : resolve());
				}
			}).catch(err => {
				reject(config.decorators.apiCallError('error occurred while fetching the pages', err));
			});
		});
	});
	return Promise.all(readyPromises)
		.then(() => resolve(config))
		.catch(err => reject(err));
});
