import {BLINKLOADER_API_URL} from '../../env';

export default config => new Promise((resolve, reject) => {
	const readyPromises = [];
	config.pages.forEach((page, i) => {
		const url = `${BLINKLOADER_API_URL}/page/link?page=${page}&api-key=${config.config.getApiKey()}&project-id=${config.projectID}`;
		readyPromises[i] = new Promise((resolve, reject) => {
			config.fetch(url).then(res => {
				if (res.status === 200) {
					return res.json();
				}
				reject(config.decorators.apiCallError('error occurred while fetching the links for pages', res.statusText));
			}).then(json => {
				if (json.errorMessage) {
					reject(config.decorators.error('error occurred while fetching the links for pages: ' + json.errorMessage));
				} else if (json.link) {
					config.pageLinks[i] = json.link;
					resolve();
				}
			}).catch(err => {
				reject(config.decorators.apiCallError('error occurred while fetching the links for pages', err));
			});
		});
	});
	return Promise.all(readyPromises)
		.then(() => resolve(config))
		.catch(err => reject(err));
});
