import {BLINKLOADER_API_URL} from '../../env';

// Start optimization for every page
export default config => new Promise((resolve, reject) => {
	const startPromises = [];
	config.pages.forEach((page, i) => {
		startPromises[i] = new Promise((resolve, reject) => {
			config.fetch(`${BLINKLOADER_API_URL}/optimization/start?page=${page}&api-key=${config.config.getApiKey()}&project-id=${config.projectID}`).then(res => {
				if (res.status === 200) {
					return res.json();
				}
				reject(config.decorators.apiCallError('error occurred while requesting optimizations', res.statusText));
			}).then(json => {
				if (json && json.errorMessage) {
					reject(config.decorators.error('error occurred while requesting optimizations: ' + json.errorMessage));
				}
				config.decorators.checkbox(`requested optimization for ${config.decorators.gray(config.pages[i])}`);
				resolve();
			}).catch(err => {
				reject(config.decorators.apiCallError('error occurred while requesting optimizations', err));
			});
		});
	});
	return Promise.all(startPromises)
		.then(() => resolve(config))
		.catch(err => reject(err));
});
