import {BLINKLOADER_API_URL} from '../../env';

// Monitor optimization status for each page
export default config => new Promise((resolve, reject) => {
	const readyPromises = [];
	config.pages.forEach((page, i) => {
		const url = `${BLINKLOADER_API_URL}/optimization/status?page=${page}&api-key=${config.config.getApiKey()}&project-id=${config.projectID}`;
		const monitor = (page, i, url) => new Promise((resolve, reject) => {
			setTimeout(() => reject(new Error('something went wrong, let us know')), 500000);
			const checkPage = () => config.fetch(url).then(res => {
				if (res.status === 200) {
					return res.json();
				}
				reject(config.decorators.apiCallError('optimization status', res.statusText));
			}).then(json => {
				if (json.errorMessage) {
					return reject(config.decorators.error('optimization status: ' + json.errorMessage));
				}
				if (json.status === 'ok') {
					config.decorators.checkbox(`optimized ${config.decorators.gray(config.pages[i])}`);
					return resolve();
				}
				setTimeout(() => checkPage(), 8000);
			}).catch(err => {
				reject(config.decorators.apiCallError('optimization status', err));
			});
			return checkPage();
		});
		readyPromises[i] = monitor(page, i, url);
	});
	return Promise.all(readyPromises)
		.then(() => resolve(config))
		.catch(err => reject(err));
});
