import colors from 'colors/safe';
import exit from 'exit';

const space = () => '    ';

const gray = text => colors.gray(text);
const blue = text => colors.blue(text);
const green = text => colors.green(text);
const red = text => colors.red(text);
const yellow = text => colors.yellow(text);
const white = text => colors.white(text);

const n = () => console.log('\n');
const p = text => console.log(text);
const log = text => p(space() + text);
const message = (type, text) => log(type + text);
const q = (text, mainColor, qColor) => {
	mainColor = mainColor || white;
	qColor = qColor || blue;
	console.log(mainColor('[') + qColor('?') + mainColor(`] ${text}`));
};

const checkbox = text => {
	message(green('DONE') + '      ', text);
};

const info = text => {
	message(yellow('INFO') + '      ', text);
};

const quit = () => {
	n();
	exit();
};

const error = errText => {
	message(red('ERROR') + '     ', errText);
};

const errorExit = errText => {
	error(errText);
	quit();
};

const apiCallError = (action, errText) => {
	message(red('ERROR') + '     ', action + ': got response from server: ' + errText);
};

const decorators = {red, blue, yellow, green, white, gray, p, q, n, space, log, message, checkbox, info, error, errorExit, apiCallError, quit};
export default decorators;

export {red, blue, yellow, green, white, gray, p, q, n, space, log, message, checkbox, info, error, errorExit, apiCallError, quit};

