import decoratorsMock from '../utils/decorators-mock';

export default (res, json) => ({ 
	pages: [],
	pageLinks: [],

	assets: [],
	assetLinks: {},

	projectID: '',
	optimizationCreated: false,


	config: {
		getSiteDir() { return '.'},
		getSiteOptimizedDir() { return '..';},

		getStack() { return 'defstring'},
		blinkloaderDir() { return 'defstring'},
		getSiteArchive() { return 'defstring'; },
		getApiKey() { return 'apikey' },

		file: 'some file name',
		walkDir() { return [this.file] },

		optimizations: [
			'instant-css',
			'adaptive-images',
			'images',
			'webp',
			'async-js',
			'minify',
			'gzip'
		],
		getOptimizations() { return this.optimizations }
	},

	decorators: decoratorsMock,
	fetch: url => new Promise((resolve, reject) => {
		if (res.status != 200) {
			return reject('bad status')
		}
		resolve({
			status: 200,
			json: () => new Promise((resolve, reject) => {
				resolve(json)
			})
		})
	}),
});
