import createOptimization from '../../../../src/commands/optimize/create-optimization';
import initConfig from '../config-mock';

describe('create-optimization stage test', () => {
	it('should reject if res.status != 200 ', (done) => {
		const res = {
			status: 404,
			statusText: "not found"
		};
		const json = {}

		const config = initConfig(res, json);
		createOptimization(initConfig(res, json))
			.catch(err => { 
				expect(err).toBe('error');
				done();
			})
	});

	it('should reject if json.errorMessage', (done) => {
		const res = { status: 200 };
		const json = { errorMessage: 'some bad thing happened' };

		const config = initConfig(res, json);
		createOptimization(config)
			.catch(err => { 
				expect(err).toBe('error');
				done();
			})
	});

	it('should set config.projectID to "pID"', (done) => {
		const res = { status: 200 };
		const json = { 'project-id': "pID"};

		createOptimization(initConfig(res, json))
			.then(c => {
				expect(c.projectID).toBe('pID');
				done();
			})
	})
});
