import downloadPages from '../../../../src/commands/optimize/download-pages';
import initConfig from '../config-mock';

describe('download-pages stage test', () => {
	it('should reject if res.status != 200', (done) =>  {
		const res = {
			status: 404,
			statusText: "not found"
		};
		const json = {}

		const config = initConfig(res, json);
		config.pageLinks = ['some link'];

		downloadPages(config)
			.catch(err => { 
				expect(err).toBe('apiCallError');
				done();
			})
	});

	it('should reject if json.errorMessage', (done) => {
		const res = { status: 200 };
		const json = { errorMessage: 'some bad thing happened' };

		const config = initConfig(res, json);
		config.pages = ['some page'];
		config.pageLinks = ['some link'];

		downloadPages(config)
			.catch(err => { 
				expect(err).toBe('error');
				done();
			})
	});

	it('should reject if json.errorMessage', (done) => {
		const res = { status: 200 };
		const json = { errorMessage: 'some bad thing happened' };

		const config = initConfig(res, json);
		config.pages = ['some page'];
		config.pageLinks = ['some link'];

		downloadPages(config)
			.catch(err => { 
				expect(err).toBe('error');
				done();
			})
	});

	it('should ', (done) => {
		const res = { status: 200 };
		const json = { 
			page: 'some page'	
		};

		const config = initConfig(res, json);
		config.pages = ['some page'];
		config.pageLinks = ['some link'];
		config.config.writeFile = (p1, p2, cb) => cb();

		downloadPages(config)
			.then(c => { 
				expect(c).toBe(config)
				done();
			});
	});
});
