import fetchPageLinks from '../../../../src/commands/optimize/fetch-page-links';
import initConfig from '../config-mock';

describe('fetch-page-links stage test', () => {
	it('should reject if res.status != 200', (done) => {
		const res = { status: 404 };
		const json = {};
		const config = initConfig(res, json);
		config.pages = ['some page'];

		fetchPageLinks(config)
			.catch(err => {
				expect(err).toBe('apiCallError');
				done();
			})
	});

	it('should reject if json.errorMessage', (done) => {
		const res = { status: 200 };
		const json = {errorMessage: "some error"};
		const config = initConfig(res, json);
		config.pages = ['some page'];

		fetchPageLinks(config)
			.catch(err => { 
				expect(err).toBe('error');
				done();
			})
	});

	it('should resolve if json.link exist', (done) => {
		const res = { status: 200 };
		const json = { link: 'some link'};
		const config = initConfig(res, json);
		config.pages = ['some page'];
		config.pageLinks = [];

		fetchPageLinks(config)
			.then(config => { 
				expect(config.pageLinks[0]).toBe('some link');
				done();
			})
	});
});
