import fs from 'fs';

import minifyAssets from '../../../../src/commands/optimize/minify-assets';
import initConfig from '../config-mock';

describe('fetch-page-links stage test', () => {
	it('should resolve if minify is not in the optimizations list', (done) => {
		const config = initConfig();
		config.config.optimizations = [];
					
		minifyAssets(config).then(c => {
			expect(c).toBe(config);
			done();
		});
	});

	it('should resolve if minify is not in the optimizations list', (done) => {
		const config = initConfig();
		fs.writeFileSync('./asset.js', 'console.log( "hello and goodbye world" );')
		config.assets = ['/asset.js'];
					
		minifyAssets(config).then(c => {
			expect(c).toBe(config)
			expect(fs.readFileSync('../asset.js').data).toBe(new Buffer('console.log("hello and goodbye world");').data);
			fs.unlinkSync('../asset.js');
			done();
		});
	});
});
