import startOptimization from '../../../../src/commands/optimize/start-optimization';
import initConfig from '../config-mock';

describe('start-optimization stage test', () => {
	it('should apiCallError if res.status != 200', (done) => {
		const res = {
			status: 404,
			statusText: "not found"
		};
		const json = {}
		const config = initConfig(res, json);
		config.pages = ['some page'];

		startOptimization(config)
			.catch(err => {
				expect(err).toBe('apiCallError');
				done();
			})
	});

	it('should error if json.errorMessage is returned', (done) => {
		const res = { status: 200 };
		const json = { errorMessage: "some error returned" }; 
		const config = initConfig(res, json);
		config.pages = ['some page'];

		startOptimization(config)
			.catch(err => { 
				expect(err).toBe('error');
				done();
			})
	});

	it('should resolve otherwise', (done) => {
		const res = { status: 200 };
		const json = {};
		const config = initConfig(res, json);
		config.pages = ['some page'];

		startOptimization(config)
			.then(c => { 
				expect(c).toBe(config);
				done();
			})
	});
});
