import waitOptimization from '../../../../src/commands/optimize/wait-optimization';
import initConfig from '../config-mock';

describe('wait-optimization stage test', () => {
	it('should apiCallError if status != 200 for some page', (done) => {
		const res = { status: 404 };
		const json = { errorMessage: "useless" };
		const config = initConfig(res, json);
		config.pages = ['some page'];

		waitOptimization(config).catch(err => {
			expect(err).toBe('apiCallError');
			done();
		});
	});

	it('should error if json.errorMessage returned', (done) => {
		const res = { status: 200 };
		const json = { errorMessage: 'some error' };
		const config = initConfig(res, json);
		config.pages = ['some page'];

		waitOptimization(config).catch(err => {
			expect(err).toBe('error');
			done();
		});
	});

	it('should resolve if json.status == "ok"', (done) => {
		const res = { status: 200 };
		const json = { status: 'ok' };
		const config = initConfig(res, json);
		config.pages = ['some page'];

		waitOptimization(config).then(c => {
			expect(c).toBe(config);
			done();
		});
	});
});
