'use strict';Object.defineProperty(exports,'__esModule',{value:!0});var _exit=require('exit'),_exit2=_interopRequireDefault(_exit),_queue=require('queue'),_queue2=_interopRequireDefault(_queue),_progress=require('progress'),_progress2=_interopRequireDefault(_progress),_decorators=require('../../utils/decorators'),_config=require('../../utils/config'),_config2=_interopRequireDefault(_config);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var config=new _config2.default('./blinkloader.json'),fs=require('fs'),ncp=require('copy-paste'),AWS=require('aws-sdk'),glob=require('glob'),q=(0,_queue2.default)({concurrency:1});exports.default=function(clientConfig){var _process$env=process.env,AWS_REGION=_process$env.AWS_REGION,AWS_ACCESS_KEY_ID=_process$env.AWS_ACCESS_KEY_ID,AWS_SECRET_ACCESS_KEY=_process$env.AWS_SECRET_ACCESS_KEY;AWS_REGION&&AWS_ACCESS_KEY_ID&&AWS_SECRET_ACCESS_KEY||((0,_decorators.error)('blinkloader relies on your Amazon credentials, some of them were not provided'),(0,_decorators.error)((0,_decorators.gray)('AWS_REGION, AWS_ACCESS_KEY_ID, AWS_SECRET_ACCESS_KEY are required')),(0,_decorators.n)(),(0,_exit2.default)());var gzipExts=['js','css','html','htm','png','jpg','jpeg','gif'],s3=new AWS.S3;q.push(function(cb){s3.createBucket({Bucket:clientConfig.domain},function(err){err&&'BucketAlreadyOwnedByYou'===err.code?((0,_decorators.checkbox)('bucket '+(0,_decorators.gray)(clientConfig.domain)+' already exists'),AWS_REGION=err.region,cb()):err&&'UnknownEndpoint'===err.code?((0,_decorators.error)('blinkloader relies on your Amazon credentials, some of them are not valid'),(0,_decorators.n)(),(0,_exit2.default)()):err?((0,_decorators.error)('something went wrong'),console.log(JSON.stringify(err)),(0,_decorators.n)(),(0,_exit2.default)()):((0,_decorators.checkbox)('created new s3 bucket '+(0,_decorators.gray)(clientConfig.domain)),cb())})}),q.push(function(cb){glob(config.getSiteOptimizedDir()+'/**/*.*',{},function(er,files){var filesMap=files.map(function(file){var ContentType=void 0,CacheControl=void 0,ContentEncoding=void 0,fileExtension=file.split('.')[file.split('.').length-1];return config.getOptimizations().includes('gzip')&&gzipExts.includes(fileExtension)&&(ContentEncoding='gzip'),'png'===fileExtension?(ContentType='image/png',CacheControl='max-age=31536000'):'jpg'===fileExtension||'jpeg'===fileExtension?(ContentType='image/jpeg',CacheControl='max-age=31536000'):'webp'===fileExtension?(ContentType='image/webp',CacheControl='max-age=31536000'):'gif'===fileExtension?(ContentType='image/gif',CacheControl='max-age=31536000'):'svg'===fileExtension?(ContentType='image/svg+xml',CacheControl='max-age=31536000'):'css'===fileExtension?(ContentType='text/css',CacheControl='max-age=31536000'):'json'===fileExtension?(ContentType='application/json',CacheControl='max-age=31536000'):'html'===fileExtension||'htm'===fileExtension?(ContentType='text/html',CacheControl='no-cache'):'js'===fileExtension?CacheControl='max-age=31536000':'webm'===fileExtension&&(CacheControl='max-age=31536000'),{file:file,ContentType:ContentType,CacheControl:CacheControl,ContentEncoding:ContentEncoding,target:file.replace(config.getSiteOptimizedDir()+'/','')}}),totalUploaded=0,totalFiles=files.length;(0,_decorators.checkbox)('started syncing the bucket with '+(0,_decorators.gray)(config.getSiteOptimizedDir()));var bar=new _progress2.default('              uploading [:bar] :percent',{total:totalFiles,complete:'=',incomplete:' ',width:20});filesMap.forEach(function(fileMap){fs.readFile(fileMap.file,function(err,fileContent){var params={Body:fileContent,CacheControl:fileMap.CacheControl,ContentEncoding:fileMap.ContentEncoding,ContentType:fileMap.ContentType,Bucket:clientConfig.domain,Key:fileMap.target};s3.upload(params,function(uploaderr){uploaderr&&((0,_decorators.error)('something went wrong, couldn\'t send assets to the bucket'),console.log(JSON.stringify(uploaderr)),(0,_decorators.n)(),(0,_exit2.default)()),totalUploaded++,bar.tick(),bar.complete&&(0,_decorators.n)(),totalUploaded===totalFiles&&cb()})})})})});var errorPageKey=null;q.push(function(cb){fs.stat(config.getSiteOptimizedDir()+'/404/index.html',function(err,exists){exists?(errorPageKey='404/index.html',cb()):fs.stat(config.getSiteOptimizedDir()+'/404.html',function(err,exists){exists&&(errorPageKey='404.html'),cb()})})}),q.push(function(cb){var staticHostParams={Bucket:clientConfig.domain,WebsiteConfiguration:{IndexDocument:{Suffix:'index.html'}}};errorPageKey&&(staticHostParams.WebsiteConfiguration.ErrorDocument={Key:errorPageKey}),s3.putBucketWebsite(staticHostParams,function(err){err?((0,_decorators.error)('something went wrong, couldn\'t set static website parameters'),console.log(JSON.stringify(err)),(0,_exit2.default)(),(0,_decorators.n)()):(0,_decorators.checkbox)('set up static website parameters'),cb()})}),q.push(function(cb){var params={Bucket:clientConfig.domain,Policy:'{ "Version":"2012-10-17", "Statement":[{ "Sid":"PublicReadGetObject", "Effect":"Allow", "Principal": "*", "Action":["s3:GetObject"], "Resource":["arn:aws:s3:::'+clientConfig.domain+'/*"] }] }'};s3.putBucketPolicy(params,function(err){err?((0,_decorators.error)('something went wrong, couldn\'t set the bucket policy'),(0,_exit2.default)(),(0,_decorators.n)()):(0,_decorators.checkbox)('set up the bucket policy to make your website available'),cb()})}),q.start(function(){(0,_decorators.n)();var websiteLink='http://'+clientConfig.domain+'.s3-website-'+AWS_REGION+'.amazonaws.com';ncp.copy(websiteLink,function(){(0,_decorators.checkbox)('Woohoo, it\'s deployed!'),(0,_decorators.checkbox)(''+(0,_decorators.gray)(websiteLink)),(0,_decorators.checkbox)('copied the link to clipboard, use Ctrl-V to paste anywhere'),(0,_decorators.n)()})})};